'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 20 December 2010 at 7:54:57 pm'!

!Theme methodsFor: 'private' stamp: 'cbr 12/20/2010 19:49'!
instVar
	^ #(
		instVar
		blockStart2
		blockEnd2
		leftParenthesis2
		rightParenthesis2
	)! !


!ThemesTest methodsFor: 'as yet unclassified' stamp: 'cbr 12/19/2010 16:46'!
setUp
	"Create an anonymous subclass of Theme, override #shout.
	We do this because the ouput of #generateShoutConfig, the
	method under test, is dependent on the color data answered 
	by #shout, and we don't want the test to fail just because 
	someone changed the colors on the default theme (Theme.)"

	| metaclass |

	metaclass := Metaclass new
		superclass: Theme class;
		methodDictionary: MethodDictionary new;
		setFormat: Theme class format;
		yourself.

	theme := metaclass new
		superclass: Theme;
		methodDictionary: MethodDictionary new;
		setFormat: Theme format;
		yourself.
		
	theme compile:
'	shout
	"Color symbols as an association list."
	
	^ {
		#defaults 				-> #black.
		#undefined 			-> #green.
		#methodTags 			-> #(green muchDarker).
		#pseudoVariables 		-> #(red muchDarker).
		#messages 			-> #(blue muchDarker).
		#instVar 				-> #(magenta muchDarker).
		#incompleteMessages -> #(gray veryMuchDarker).
		#blockLevelFour 		-> #(green darker).
		#blockLevelFive 		-> #(orange darker).
		#blockLevelSix 		-> #(magenta darker).
		#blockLevelSeven 		-> #blue.
		#tempBar 				-> #gray.
		#tempVars 			-> #(gray muchDarker).
	}
'! !

