'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 18 April 2008 at 9:49:59 am'!

!StrikeFont methodsFor: 'accessing' stamp: 'jmv 4/17/2008 23:17'!
baseKern
	"Return the base kern value to be used for all characters."
	true ifTrue: [^0].
	(emphasis noMask: 2) ifTrue: [^ 0].
	^ ((self height-1-self ascent+4)//4 max: 0)  "See makeItalicGlyphs"
		+ (((self ascent-5+4)//4 max: 0))
! !


!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 4/17/2008 22:20'!
derivativeFont: aStrikeFont at: index

	| newDeriv |
	aStrikeFont ifNil: [derivativeFonts := nil. ^ self].
	derivativeFonts ifNil: [derivativeFonts := Array new: 32].
	derivativeFonts size < 32 ifTrue: [
		newDeriv := Array new: 32.
		newDeriv replaceFrom: 1 to: derivativeFonts size with: derivativeFonts.
		derivativeFonts := newDeriv.
	].
	derivativeFonts at: index put: aStrikeFont.! !


!StrikeFont class methodsFor: 'instance creation' stamp: 'jmv 4/18/2008 09:47'!
installAAVera
"
StrikeFont installAAVera
"
	| baseF base boldF italicF bold italic |
	baseF := {'AAFonts\Vera8.bmp'-> 'Vera 8'. 'AAFonts\Vera10.bmp'-> 'Vera 10'. 'AAFonts\Vera12.bmp'-> 'Vera 12'. 'AAFonts\Vera16.bmp'-> 'Vera 16'. 'AAFonts\Vera18.bmp'-> 'Vera 18'}.
	boldF := {'AAFonts\Vera8b.bmp'-> 'Vera 8B'. 'AAFonts\Vera10b.bmp'-> 'Vera 10B'. 'AAFonts\Vera12b.bmp'-> 'Vera 12B'. 'AAFonts\Vera16b.bmp'-> 'Vera 16B'}.
	italicF := {'AAFonts\Vera10i.bmp'-> 'Vera 10I'. 'AAFonts\Vera12i.bmp'-> 'Vera 12I'. 'AAFonts\Vera16i.bmp'-> 'Vera 16I'. 'AAFonts\Vera18i.bmp'-> 'Vera 18I'}.
	base := OrderedCollection new.
	bold := OrderedCollection new.
	italic := OrderedCollection new.
	
			baseF withIndexDo: [:keyValue :index | |form |	
					form _ Form fromFileNamed:keyValue key.
					base add: (StrikeFont new buildFromForm: form name: keyValue value)].
			boldF withIndexDo: [:keyValue :index | |form |
					form _ Form fromFileNamed:keyValue key.
					bold add: ((StrikeFont new buildFromForm: form name: keyValue value) emphasis: 1)].
			italicF withIndexDo: [:keyValue :index | |form |
					form _ Form fromFileNamed:keyValue key.
					italic add: ((StrikeFont new buildFromForm: form name: keyValue value)emphasis:2)].
			
			(base at: 1) derivativeFont: (bold at: 1) at: 1.
			(base at: 2) derivativeFont: (bold at: 2) at: 1.
			(base at: 3) derivativeFont: (bold at: 3) at: 1.
			(base at: 4) derivativeFont: (bold at: 4) at: 1.

			(base at: 2) derivativeFont: (italic at: 1) at: 2.
			(base at: 3) derivativeFont: (italic at: 2) at: 2.
			(base at: 4) derivativeFont: (italic at: 3) at: 2.
			(base at: 5) derivativeFont: (italic at: 4) at: 2.

			TextConstants at: #Vera put: (TextStyle fontArray: base).
"
			Preferences setDefaultFonts: #(
				(setSystemFontTo: 'Vera' 10)
				(setListFontTo: 'Vera' 10)
				(setMenuFontTo: 'Vera' 12)
				(setWindowTitleFontTo: 'Vera Bold' 12)
				(setBalloonHelpFontTo: 'Vera' 10)
				(setCodeFontTo: 'Vera' 12)
				(setButtonFontTo: 'Vera' 10))
"! !

