'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 18 December 2010 at 7:21:18 pm'!

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'cbr 12/18/2010 19:19'!
createAcceptButton
	"create the [accept] button"
	| result frame buttonColor theme |
	theme _ Theme current.
	theme useUniformColors
		ifTrue: [ buttonColor _ theme buttonColorFrom: theme defaultWindowColor ]
		ifFalse: [ buttonColor _ theme acceptButton].
	result _ PluggableButtonMorph new
		 model: self;
		 color: buttonColor;
		 label: 'Accept(s)' translated;
		 action: #accept.
	frame _ LayoutFrame fractions: (0.1 @ 0.75 corner: 0.45 @ 0.98).
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'cbr 12/18/2010 19:18'!
createCancelButton
	"create the [cancel] button"
	| result frame buttonColor theme |
	theme _ Theme current.
	theme useUniformColors
		ifTrue: [ buttonColor _ theme buttonColorFrom: theme defaultWindowColor ]
		ifFalse: [ buttonColor _ theme buttonColorFrom: theme cancelButton ].
	result _ PluggableButtonMorph new
		 model: self;
		 color: buttonColor;
		 label: 'Cancel(l)' translated;
		 action: #cancel.
	frame _ LayoutFrame fractions: (0.55 @ 0.75 corner: 0.9 @ 0.98).
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !


!Theme methodsFor: 'widget colors' stamp: 'cbr 12/18/2010 19:08'!
acceptButton
	^ self buttonColorFrom: (Color r: 0.5 g: 0.8 b: 0.5)! !

!Theme methodsFor: 'widget colors' stamp: 'cbr 12/18/2010 19:12'!
cancelButton
	^ self buttonColorFrom: (Color r: 0.8 g: 0.5 b: 0.5)! !

