'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 24 December 2010 at 12:59:35 am'!

!SHTextStylerST80 methodsFor: 'private' stamp: 'jmv 12/24/2010 00:44'!
privateStyle
	| ranges |
	ranges_ self rangesIn: formattedText setWorkspace: true.
	ranges ifNotNil: [ self setAttributesIn: formattedText fromRanges: ranges in: nil ]! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'jmv 12/24/2010 00:48'!
setAttributesIn: aText fromRanges: ranges in: anInterval
	"modified by jmv to keep existing attributes if they answer true to #isParagraphAttribute"
	| attributes defaultAttributes paragraphAttributes attr newRuns newValues lastAttr lastCount beginning chunkRuns end | 		

	anInterval
		ifNil: [
			beginning _ 1.
			end _ aText size ]
		ifNotNil: [
			beginning _ anInterval first.
			end _ anInterval last ].
	defaultAttributes := self attributesFor: #default.
	paragraphAttributes := Array new: end-beginning+1.
	1 to: paragraphAttributes size do: [ :i |
		paragraphAttributes at: i put:
			((aText attributesAt: i+beginning-1) select: [ :each | each isParagraphAttribute ])].
	attributes := Array new: end-beginning+1.
	1 to: attributes size do: [ :i | attributes at: i put: (paragraphAttributes at: i), defaultAttributes].
	ranges do: [ :range |
		(attr := self attributesFor: range type)
			ifNotNil: [ range start to: range end do: [:i |
				attributes at: i put: (paragraphAttributes at: i), attr]]].
	newRuns := OrderedCollection new: attributes size // 10.
	newValues := OrderedCollection new: attributes size // 10.
	1 to: attributes size do: [:i |
		attr := attributes at: i.
		i = 1 
			ifTrue: [
				newRuns add: 1.
				lastCount := 1.
				lastAttr := newValues add: attr]
			ifFalse:[
				attr == lastAttr
					ifTrue: [
						lastCount := lastCount + 1.
						newRuns at: newRuns size put: lastCount]
					ifFalse: [
						newRuns add: 1.
						lastCount := 1.
						lastAttr := newValues add: attr]]].
	chunkRuns _ (RunArray runs: newRuns values: newValues) coalesce.
	aText privateSetRuns: (aText runs copyReplaceFrom: beginning to: end with: chunkRuns)! !

SHTextStylerST80 removeSelector: #setAttributesIn:fromRanges:!
